import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _createClass from "@babel/runtime/helpers/createClass";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { registerMetadataTransducer as _registerMetadataTransducer, getRegisteredMetadataTransducers as _getRegisteredMetadataTransducers, addBuiltinComponentAction as _addBuiltinComponentAction, removeBuiltinComponentAction as _removeBuiltinComponentAction, modifyBuiltinComponentAction as _modifyBuiltinComponentAction, isComponentMeta as _isComponentMeta } from '@alilc/lowcode-designer';
import { editorSymbol, designerSymbol } from './symbols';
import ComponentMeta from './component-meta';

var Material = /*#__PURE__*/function () {
  function Material(editor) {
    this[editorSymbol] = void 0;
    this[designerSymbol] = void 0;
    this[editorSymbol] = editor;
    this[designerSymbol] = editor.get('designer');
  }
  /**
   * 获取组件 map 结构
   */


  var _proto = Material.prototype;

  /**
   * 设置「资产包」结构
   * @param assets
   * @returns
   */
  _proto.setAssets =
  /*#__PURE__*/
  function () {
    var _setAssets = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(assets) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this[editorSymbol].setAssets(assets);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function setAssets(_x) {
      return _setAssets.apply(this, arguments);
    }

    return setAssets;
  }()
  /**
   * 获取「资产包」结构
   * @returns
   */
  ;

  _proto.getAssets = function getAssets() {
    return this[editorSymbol].get('assets');
  }
  /**
   * 加载增量的「资产包」结构，该增量包会与原有的合并
   * @param incrementalAssets
   * @returns
   */
  ;

  _proto.loadIncrementalAssets = function loadIncrementalAssets(incrementalAssets) {
    return this[designerSymbol].loadIncrementalAssets(incrementalAssets);
  }
  /**
   * 注册物料元数据管道函数
   * @param transducer
   * @param level
   * @param id
   */
  ;

  _proto.registerMetadataTransducer = function registerMetadataTransducer(transducer, level, id) {
    _registerMetadataTransducer(transducer, level, id);
  }
  /**
   * 获取所有物料元数据管道函数
   * @returns
   */
  ;

  _proto.getRegisteredMetadataTransducers = function getRegisteredMetadataTransducers() {
    return _getRegisteredMetadataTransducers();
  }
  /**
   * 获取指定名称的物料元数据
   * @param componentName
   * @returns
   */
  ;

  _proto.getComponentMeta = function getComponentMeta(componentName) {
    return ComponentMeta.create(this[designerSymbol].getComponentMeta(componentName));
  }
  /**
   * create an instance of ComponentMeta by given metadata
   * @param metadata
   * @returns
   */
  ;

  _proto.createComponentMeta = function createComponentMeta(metadata) {
    return ComponentMeta.create(this[designerSymbol].createComponentMeta(metadata));
  }
  /**
   * test if the given object is a ComponentMeta instance or not
   * @param obj
   * @returns
   */
  ;

  _proto.isComponentMeta = function isComponentMeta(obj) {
    return _isComponentMeta(obj);
  }
  /**
   * 获取所有已注册的物料元数据
   * @returns
   */
  ;

  _proto.getComponentMetasMap = function getComponentMetasMap() {
    var map = new Map();
    var originalMap = this[designerSymbol].getComponentMetasMap();

    for (var componentName in originalMap.keys()) {
      map.set(componentName, this.getComponentMeta(componentName));
    }

    return map;
  }
  /**
   * 在设计器辅助层增加一个扩展 action
   * @param action
   */
  ;

  _proto.addBuiltinComponentAction = function addBuiltinComponentAction(action) {
    _addBuiltinComponentAction(action);
  }
  /**
   * 移除设计器辅助层的指定 action
   * @param name
   */
  ;

  _proto.removeBuiltinComponentAction = function removeBuiltinComponentAction(name) {
    _removeBuiltinComponentAction(name);
  }
  /**
   * 修改已有的设计器辅助层的指定 action
   * @param actionName
   * @param handle
   */
  ;

  _proto.modifyBuiltinComponentAction = function modifyBuiltinComponentAction(actionName, handle) {
    _modifyBuiltinComponentAction(actionName, handle);
  }
  /**
   * 监听 assets 变化的事件
   * @param fn
   */
  ;

  _proto.onChangeAssets = function onChangeAssets(fn) {
    // 设置 assets，经过 setAssets 赋值
    this[editorSymbol].onGot('assets', fn); // 增量设置 assets，经过 loadIncrementalAssets 赋值

    this[editorSymbol].on('designer.incrementalAssetsReady', fn);
  };

  _createClass(Material, [{
    key: "componentsMap",
    get: function get() {
      return this[designerSymbol].componentsMap;
    }
  }]);

  return Material;
}();

export { Material as default };