import { Prop as InnerProp } from '@alilc/lowcode-designer';
import { CompositeValue, TransformStage } from '@alilc/lowcode-types';
import { propSymbol } from './symbols';
import Node from './node';
export default class Prop {
    private readonly [propSymbol];
    constructor(prop: InnerProp);
    static create(prop: InnerProp | undefined | null): Prop;
    /**
     * id
     */
    get id(): string;
    /**
     * key 值
     */
    get key(): string | number;
    /**
     * 返回当前 prop 的路径
     */
    get path(): string[];
    /**
     * 返回所属的节点实例
     */
    get node(): Node | null;
    /**
     * return the slot node (only if the current prop represents a slot)
     */
    get slotNode(): Node | null;
    /**
     * judge if it is a prop or not
     */
    get isProp(): boolean;
    /**
     * 设置值
     * @param val
     */
    setValue(val: CompositeValue): void;
    /**
     * 获取值
     * @returns
     */
    getValue(): CompositeValue;
    /**
     * 导出值
     * @param stage
     * @returns
     */
    exportSchema(stage?: TransformStage): CompositeValue;
}
