import { DocumentModel as InnerDocumentModel } from '@alilc/lowcode-designer';
import Node from './node';
import { documentSymbol, selectionSymbol } from './symbols';
export default class Selection {
    private readonly [documentSymbol];
    private readonly [selectionSymbol];
    constructor(document: InnerDocumentModel);
    /**
     * 返回选中的节点 id
     */
    get selected(): string[];
    /**
     * return selected Node instance
     */
    get node(): Node;
    /**
     * 选中指定节点（覆盖方式）
     * @param id
     */
    select(id: string): void;
    /**
     * 批量选中指定节点们
     * @param ids
     */
    selectAll(ids: string[]): void;
    /**
     * 移除选中的指定节点
     * @param id
     */
    remove(id: string): void;
    /**
     * 清除所有选中节点
     */
    clear(): void;
    /**
     * 判断是否选中了指定节点
     * @param id
     * @returns
     */
    has(id: string): boolean;
    /**
     * 选中指定节点（增量方式）
     * @param id
     */
    add(id: string): void;
    /**
     * 获取选中的节点实例
     * @returns
     */
    getNodes(): Node[];
}
