import _createClass from "@babel/runtime/helpers/createClass";
import { isCustomView } from '@alilc/lowcode-types';
import { settingPropEntrySymbol } from './symbols';
import Node from './node';
import SettingTopEntry from './setting-top-entry';
import ComponentMeta from './component-meta';

var SettingPropEntry = /*#__PURE__*/function () {
  function SettingPropEntry(prop) {
    this[settingPropEntrySymbol] = void 0;
    this[settingPropEntrySymbol] = prop;
  }

  SettingPropEntry.create = function create(prop) {
    return new SettingPropEntry(prop);
  }
  /**
   * 获取设置属性的 isGroup
   */
  ;

  var _proto = SettingPropEntry.prototype;

  /**
   * 设置 key 值
   * @param key
   */
  _proto.setKey = function setKey(key) {
    this[settingPropEntrySymbol].setKey(key);
  }
  /**
   * @deprecated use .node instead
   */
  ;

  _proto.getNode = function getNode() {
    return this.node;
  }
  /**
   * @deprecated use .parent instead
   */
  ;

  _proto.getParent = function getParent() {
    return this.parent;
  }
  /**
   * 设置值
   * @param val 值
   */
  ;

  _proto.setValue = function setValue(val, extraOptions) {
    this[settingPropEntrySymbol].setValue(val, false, false, extraOptions);
  }
  /**
   * 设置子级属性值
   * @param propName 子属性名
   * @param value 值
   */
  ;

  _proto.setPropValue = function setPropValue(propName, value) {
    this[settingPropEntrySymbol].setPropValue(propName, value);
  }
  /**
   * 清空指定属性值
   * @param propName
   */
  ;

  _proto.clearPropValue = function clearPropValue(propName) {
    this[settingPropEntrySymbol].clearPropValue(propName);
  }
  /**
   * 获取配置的默认值
   * @returns
   */
  ;

  _proto.getDefaultValue = function getDefaultValue() {
    return this[settingPropEntrySymbol].getDefaultValue();
  }
  /**
   * 获取值
   * @returns
   */
  ;

  _proto.getValue = function getValue() {
    return this[settingPropEntrySymbol].getValue();
  }
  /**
   * 获取子级属性值
   * @param propName 子属性名
   * @returns
   */
  ;

  _proto.getPropValue = function getPropValue(propName) {
    return this[settingPropEntrySymbol].getPropValue(propName);
  }
  /**
   * 获取设置属性集
   * @returns
   */
  ;

  _proto.getProps = function getProps() {
    return SettingTopEntry.create(this[settingPropEntrySymbol].getProps());
  }
  /**
   * 是否绑定了变量
   * @returns
   */
  ;

  _proto.isUseVariable = function isUseVariable() {
    return this[settingPropEntrySymbol].isUseVariable();
  }
  /**
   * 设置绑定变量
   * @param flag
   */
  ;

  _proto.setUseVariable = function setUseVariable(flag) {
    this[settingPropEntrySymbol].setUseVariable(flag);
  }
  /**
   * 创建一个设置 field 实例
   * @param config
   * @returns
   */
  ;

  _proto.createField = function createField(config) {
    return SettingPropEntry.create(this[settingPropEntrySymbol].createField(config));
  }
  /**
   * 获取值，当为变量时，返回 mock
   * @returns
   */
  ;

  _proto.getMockOrValue = function getMockOrValue() {
    return this[settingPropEntrySymbol].getMockOrValue();
  }
  /**
   * 销毁当前 field 实例
   */
  ;

  _proto.purge = function purge() {
    this[settingPropEntrySymbol].purge();
  }
  /**
   * 移除当前 field 实例
   */
  ;

  _proto.remove = function remove() {
    this[settingPropEntrySymbol].remove();
  }
  /**
   * 设置 autorun
   * @param action
   * @returns
   */
  ;

  _proto.onEffect = function onEffect(action) {
    return this[settingPropEntrySymbol].onEffect(action);
  }
  /**
   * 返回 shell 模型，兼容某些场景下 field 已经是 shell field 了
   * @returns
   */
  ;

  _proto.internalToShellPropEntry = function internalToShellPropEntry() {
    return this;
  };

  _createClass(SettingPropEntry, [{
    key: "isGroup",
    get: function get() {
      return this[settingPropEntrySymbol].isGroup;
    }
    /**
     * 获取设置属性的 id
     */

  }, {
    key: "id",
    get: function get() {
      return this[settingPropEntrySymbol].id;
    }
    /**
     * 获取设置属性的 name
     */

  }, {
    key: "name",
    get: function get() {
      return this[settingPropEntrySymbol].name;
    }
    /**
     * 获取设置属性的 key
     */

  }, {
    key: "key",
    get: function get() {
      return this[settingPropEntrySymbol].getKey();
    }
    /**
     * 获取设置属性的 path
     */

  }, {
    key: "path",
    get: function get() {
      return this[settingPropEntrySymbol].path;
    }
    /**
     * 获取设置属性的 title
     */

  }, {
    key: "title",
    get: function get() {
      return this[settingPropEntrySymbol].title;
    }
    /**
     * 获取设置属性的 setter
     */

  }, {
    key: "setter",
    get: function get() {
      return this[settingPropEntrySymbol].setter;
    }
    /**
     * 获取设置属性的 extraProps
     */

  }, {
    key: "extraProps",
    get: function get() {
      return this[settingPropEntrySymbol].extraProps;
    }
  }, {
    key: "props",
    get: function get() {
      return SettingTopEntry.create(this[settingPropEntrySymbol].props);
    }
    /**
     * 获取设置属性对应的节点实例
     */

  }, {
    key: "node",
    get: function get() {
      return Node.create(this[settingPropEntrySymbol].getNode());
    }
    /**
     * 获取设置属性的父设置属性
     */

  }, {
    key: "parent",
    get: function get() {
      return SettingPropEntry.create(this[settingPropEntrySymbol].parent);
    }
    /**
     * 是否是 SettingField 实例
     */

  }, {
    key: "isSettingField",
    get: function get() {
      return this[settingPropEntrySymbol].isSettingField;
    }
    /**
     * componentMeta
     */

  }, {
    key: "componentMeta",
    get: function get() {
      return ComponentMeta.create(this[settingPropEntrySymbol].componentMeta);
    }
    /**
     * 获取设置属性的 items
     */

  }, {
    key: "items",
    get: function get() {
      var _this$settingPropEntr;

      return (_this$settingPropEntr = this[settingPropEntrySymbol].items) === null || _this$settingPropEntr === void 0 ? void 0 : _this$settingPropEntr.map(function (item) {
        if (isCustomView(item)) {
          return item;
        }

        return item.internalToShellPropEntry();
      });
    }
  }]);

  return SettingPropEntry;
}();

export { SettingPropEntry as default };