import { SettingEntry } from '@alilc/lowcode-designer';
import { settingTopEntrySymbol } from './symbols';
import Node from './node';
import SettingPropEntry from './setting-prop-entry';
export default class SettingTopEntry {
    private readonly [settingTopEntrySymbol];
    constructor(prop: SettingEntry);
    static create(prop: SettingEntry): SettingTopEntry;
    /**
     * 返回所属的节点实例
     */
    get node(): Node | null;
    /**
     * 获取子级属性对象
     * @param propName
     * @returns
     */
    get(propName: string | number): SettingPropEntry;
    /**
     * @deprecated use .node instead
     */
    getNode(): Node;
    /**
     * 获取指定 propName 的值
     * @param propName
     * @returns
     */
    getPropValue(propName: string | number): any;
    /**
     * 设置指定 propName 的值
     * @param propName
     * @param value
     */
    setPropValue(propName: string | number, value: any): void;
}
