import { BuiltinSimulatorHost } from '@alilc/lowcode-designer';
import { simulatorHostSymbol } from './symbols';
export default class SimulatorHost {
    private readonly [simulatorHostSymbol];
    constructor(simulator: BuiltinSimulatorHost);
    static create(host: BuiltinSimulatorHost): SimulatorHost;
    /**
     * 获取 contentWindow
     */
    get contentWindow(): Window;
    /**
     * 获取 contentDocument
     */
    get contentDocument(): Document;
    get renderer(): import("../../designer/lib").BuiltinSimulatorRenderer;
    /**
     * 设置 host 配置值
     * @param key
     * @param value
     */
    set(key: string, value: any): void;
    /**
     * 获取 host 配置值
     * @param key
     * @returns
     */
    get(key: string): any;
    /**
     * 刷新渲染画布
     */
    rerender(): void;
}
